package no.ntnu.idatt1002.demo.data.Budget;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

//Disable next i newBudgetbert til maxamount har blitt burkt opp
//Set titler på hvert vindu - kan gjøres i switch scene
//Close program properly
//close button i first menu
//remove printstackstraces
//HVIS CONTINUE I BUDGET PRESSES, SHOWCONFIRMATION
//VIKTIG_ BALANCE LABEL ER RØD PÅ GRØNN BAKGRUNN!!!
//Binde label to total balance i budget window (newBUdgetBert)
//En delete funksjon i select old budget
//Endre pakkenavn
//Public vs private metoder må sjekkes
//Popup for edit og delete button
//confirmation for når returnBtn som returner til start. "Are you sure you want to go back. Changes will not be saved"
// FIKSE TRY CATCHES I ALLE METODENE!!!!!!!!!!
//tester for nye filklasser
//set all windows unresizable
//Bytte oversikt på dualList til Monthly ....

//System.out.println(System.getProperty("user.dir") + path); =
//C:\Users\xulr0\IdeaProjects\skoleProsjekter\idatt1002\idatt1002_2023_9src/main/resources/

//(System.getProperty("user.dir") + "/" + path) =
//(path) =
//(src/main/resources)

/**
 * Class that handles the reading and writing to the budget archive file,
 * which contains all existing budget projects. New budgets are added to the archive
 * through this class.

 * @author Harry Linrui Xu
 * @since 19.04.2023
 */
public class FileHandlingBudgetArchive {
  private static final String filePath = "src/main/resources/";
  private static final String fileType = ".archive";

  /**
   * Method for writing (adding) a budget register to the archive.

   * @param budgetNames The budget register.
   * @param fileTitle The title of the file.
   * @throws IOException if an input or output exception occurred.
   */
  public static void writeBudgetRegisterToArchive(BudgetRegister budgetNames,
      String fileTitle) throws IOException {

    try (BufferedWriter bw = new BufferedWriter(new FileWriter(filePath + fileTitle + fileType))) {
      bw.write(budgetNames.toString());
    } catch (IOException ioe) {
      throw new IOException("Could not write to file: Archive", ioe);
    }
  }

  /**
   * Checks if the budget register in the archive contains any budget names.
   * In other words, if it is empty.

   * @param fileTitle title of the file.
   * @return True, if only "null" is read. Else, returns false.
   * @throws IOException if an input or output exception occurred.
   */
  public static boolean isBudgetRegisterEmpty(String fileTitle) throws IOException {
    try (BufferedReader br = new BufferedReader(new FileReader(filePath
        + fileTitle + fileType))) {
      return br.readLine() == null;
    }
  }

  /**
   * Method for reading the budget register from the archive.
   * @param fileTitle The name of the file that contains the register.

   * @return The budget register that is read from file.
   * @throws IOException if an input or output exception occurred.
   */
  public static BudgetRegister readBudgetArchive(String fileTitle) throws IOException { //TODO
    BudgetRegister budgetRegister = null;
    String budgetName;
    String line;

    try (BufferedReader br = new BufferedReader(
        new FileReader(filePath + fileTitle + fileType))) {

      String nextLine = br.readLine();
      while ((line = nextLine) != null) {
        System.out.println(line);
        nextLine = br.readLine();
        budgetName = line;

        if (budgetRegister == null) {
          budgetRegister = new BudgetRegister();
        }
        budgetRegister.addBudgetName(budgetName);
      }
    }
    return budgetRegister;
  }

  /**
   * Method for deleting a budget directory which holds all budget, income and expense
   * data for a particular budget. This class holds this responsibility, as any budgets
   * that should be removed should have their directory deleted.

   * @param budgetId The name of the budget directory that holds all the data
   *                 for a given budget.
   * @return True, if the directory is successfully deleted. Else, returns false.
   */
  public static boolean deleteBudgetDirectory(String budgetId) {
    File targetDirectory = new File(filePath + budgetId);
    System.out.println("Deleting directory:" + targetDirectory.getPath());

    String[]entries = targetDirectory.list();
    assert entries != null;
    for(String file : entries){
      File currentFile = new File(targetDirectory.getPath(),file);
      currentFile.delete();
    }

    return targetDirectory.delete();
  }
}
